<script>

  import { beforeUpdate, onMount } from 'svelte';

  import Screen from './Screen.svelte';

  export let landscape = false;

  /*
  export let number = '1337';

  export let contacts = [
    {name: 'John Smith',  number: '0123'},
    {name: 'John Ranger', number: '5678'},
    {name: 'John Doe',    number: '9234'},
  ];

  export let messages = [
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 0},
    {from: '5678', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 1},
    {from: '9234', to: '0123', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 2},
    {from: '5555', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 3},
    {from: '1337', to: '0123', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 4},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 5},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 6},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 0},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 1},
    {from: '1337', to: '0123', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 2},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 3},
    {from: '1337', to: '0123', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 4},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 5},
    {from: '0123', to: '1337', body: 'SDFSDF $dfze^zef ze fjzeof  zefez ze zep fzejf ozejf jzef ez opjfe ', time: Math.floor(new Date / 1000) + 6},
  ];
  */

  export let number   = '';
  export let contacts = [];
  export let messages = [];
  export let app      = null;
  export let appData  = {};

  const notificationSound  = new Audio('./audio/notification.mp3');
  notificationSound.volume = 0.2;

  let inited = false;

  let _messageCount = 0;

  function setApp(_app, data = {}) {
    app     = _app;
    appData = {...data};
  }

  function onMessage(e) {

    let msg = {};
    
    try { msg = JSON.parse(e.data); } catch(e) {};

    if(msg.action === 'undefined')
      return;

    switch(msg.action) {

      case 'load' : {

        number   = msg.data.number;
        contacts = msg.data.contacts;
        messages = msg.data.messages;

        if(msg.options) {

          if(msg.options.call) {
            setApp('incomingcall', {from: msg.options.call});
          }

        }

        if(!inited)
          setTimeout(() => {inited = true}, 500);

        break;
      }

      case 'end_call' : {
        setApp(null);
        break;
      }
			
      default: break;

    }

	}

  onMount(() => {
    window.parent.postMessage(JSON.stringify({action: 'component_mounted'}), '*');
  });

  beforeUpdate(() => {

    if(inited && messages.length > _messageCount) {

      notificationSound.currentTime = 0.0;
      notificationSound.play();

    }

    _messageCount = messages.length;

  });

</script>

<style>

  @import url('https://fonts.googleapis.com/css?family=Lexend+Deca&display=swap');

  .brand {
    font-family: 'Lexend Deca', sans-serif;
    position: absolute;
    bottom: 5px;
    left: 50%;
    transform: translateX(-50%);
    color: rgba(21, 0, 0, 0.64);
    z-index: 1;
    font-size: 2em;
    font-weight: bold;
    text-shadow: 0px 1px 1px rgb(183, 0, 0);
    user-select: none;
  }

  .marvel-device .landscape .brand {
    left: 5px;
    top: 50%;
    transform: translateY(-50%);
  }

</style>

<svelte:window on:message={e => onMessage(e)}/>
<div class="marvel-device nexus5 {landscape ? 'landscape' : ''}">
  
  <div class="brand" on:mouseup={e => window.parent.postMessage(JSON.stringify({action: 'internal:window:destroy'}), '*')}>G</div>

  <div class="top-bar"></div>
  <div class="sleep"></div>
  <div class="volume"></div>
  <div class="camera"></div>
  
  <div class="screen">
    <Screen
      {setApp}
      {app}
      {appData}
      {number}
      {contacts}
      {messages}
    />
  </div>

</div>
